\chapter{Categories}
This chapter is currently under construction. The reader can find the necessary (and much more!) material e.g. in \cite{frep}.
\section{General Categories and Functors}
\subsection{Yoneda-Lemma}
\begin{lem}[Yoneda-Lemma]\label{categories:yoneda-lemma}
\leavevmode
\begin{enumerate}
\item
    Let $F:\ccat\to \setc$ be a functor and $A\in \ccat$ an object. Then for every element $u\in F(A)$, there is a natural transformation
    \begin{eqnarray*}
      \eta_u: \ccat\left(A,-\right)&\longrightarrow& F\\
      \eta_u(B): \left(A\xrightarrow{f}B\right)&\longmapsto&F(f)(u)~\left(\text{for all }B\in \ccat\right).
    \end{eqnarray*}\par
    The maps
    \begin{eqnarray*}
      \lset \text{natural transformations }\ccat\left(A,-\right)\to F\rset &
      \longrightarrow&
      F(A)\\
      \left( \eta: \ccat\left(A,-\right)\to F\right)&
      \longmapsto&
      \eta_A\left(\id_A\right)\\
      \left( \eta_u: \ccat\left(A,-\right)\to F\right)&
      \longmapsfrom &
      u
    \end{eqnarray*}
    are mutually inverse and natural in $F$ and $A$.
  \item
  Let $F:\ccat\opc\to \setc$ be a functor and $A\in \ccat$ an object. Then for every element $u\in F(A)$, there is a natural transformation
  \begin{eqnarray*}
    \eta_u: \ccat\left(-,A\right)&\longrightarrow& F\\
    \eta_u(B): \left(A\xrightarrow{f}B\right)&\longmapsto&F(f)(u)~\left(\text{for all }B\in \ccat\right).
  \end{eqnarray*}\par
  The maps
  \begin{eqnarray*}
    \lset \text{natural transformations }\ccat\left(-,A\right)\to F\rset &
    \longrightarrow&
    F(A)\\
    \left( \eta: \ccat\left(A,-\right)\to F\right)&
    \longmapsto&
    \eta_A\left(\id_A\right)\\
    \left( \eta_u: \ccat\left(A,-\right)\to F\right)&
    \longmapsfrom &
    u
  \end{eqnarray*}
  are mutually inverse and natural in $F$ and $A$.
  \end{enumerate}
\end{lem}
\begin{lem}[Yoneda-Embedding]\label{categories:yoneda-embedding}
  Let $\ccat$ be a category.
  \begin{enumerate}
    \item The functor
    \begin{eqnarray*}
      \ccat\opc &\longrightarrow & \func\left(\ccat,\setc\right)\\
      X& \longmapsto & \ccat(X,-)
    \end{eqnarray*}
    is fully faithful.
    \item The functor
    \begin{eqnarray*}
      \ccat &\longrightarrow & \func\left(\ccat\opc,\setc\right)\\
      Y& \longmapsto & \ccat(-,Y)
    \end{eqnarray*}
    is fully faithful.
  \end{enumerate}
\end{lem}
\begin{defn}
  Let $F:\ccat\to \setc$ be a functor. An object $A\in \ccat$ is a \emph{representing object of $F$}\index{object!representing}\index{representing object} if there is a natural isomorphism
  \[
  \ccat(A,-)\isomorphism F.
  \]
\end{defn}
\section{Additive and Abelian Categories}
\section{Some Homological Algebra}
\subsection{Some Diagram Lemmas}
\begin{lem}[5-Lemma]
  Let $\acat$ be an abelian category. Let
  \[
  \begin{tikzcd}
    0\ar{r}&
    X_1\ar{r}\ar{d}[right]{f_1}&
    X_2\ar{r}\ar{d}[right]{f_2}&
    X_3\ar{r}\ar{d}[right]{f_3}&
    X_4\ar{r}\ar{d}[right]{f_4}&
    X_5\ar{d}[right]{f_5}\ar{r}&
    0\\
    0\ar{r}&
    Y_1\ar{r}&
    Y_2\ar{r}&
    Y_3\ar{r}&
    Y_4\ar{r}&
    Y_5\ar{r}&
    0
  \end{tikzcd}
  \]
  be a commutative diagram in $\acat$ with exact rows. Then
  \begin{enumerate}
    \item If $f_2,f_4$ are epimorphisms and $f_5$ is a monomorphism then $f_3$ is an epimorphisms too.
    \item If $f_2,f_4$ are monomorphism and $f_1$ is an epimorphisms then $f_3$ is a monomorphism.
    \item If $f_2,f_4$ are isomorphisms, $f_1$ an epimorphisms and $f_5$ a monomorphism then $f_3$ is an isomorphism.
  \end{enumerate}
\end{lem}
\begin{proof}
  Ommited.
\end{proof}
\begin{lem}[Snake Lemma]
  Let $\acat$ be an abelian category. Let
  \[
  \begin{tikzcd}
    &
    X'\ar{r}[above]{i}\ar{d}[right]{f'}&
    X\ar{r}[above]{p}\ar{d}[right]{f}&
    X''\ar{r}\ar{d}[right]{f''}&
    0\\
    0\ar{r}&
    Y'\ar{r}[below]{j}&
    Y\ar{r}[below]{q}&
    Y''&
  \end{tikzcd}
  \]
  be a commutative diaram in $\acat$ with exact rows. Then there are induced morphisms such that the following diagram commutes
  \[
  \begin{tikzcd}
  &
  \ker f'\ar[dashed]{r}[above]{\tilde{i}}\ar{d}&
  \ker f\ar[dashed]{r}[above]{\tilde{p}}\ar{d}&
  \ker f''\ar{d}&
  \\
  &
  X'\ar{r}[above]{i}\ar{d}[right]{f'}&
  X\ar{r}[above]{p}\ar{d}[right]{f}&
  X''\ar{r}\ar{d}[right]{f''}&
  0\\
  0\ar{r}&
  Y'\ar{r}[below]{j}\ar{d}&
  Y\ar{r}[below]{q}\ar{d}&
  Y''\ar{d}&\\
  &
  \coker f'\ar[dashed]{r}{\tilde{j}}&
  \coker f\ar[dashed]{r}{\tilde{q}}&
  \coker f''&
  \end{tikzcd}
  \]
  \begin{enumerate}
    \item There is a morphism $\delta:\ker f''\to \coker f'$ such that the sequence
    \[
    \begin{tikzcd}
    \ker f'\ar{r}[above]{\tilde{i}}&
    \ker f\ar{r}[above]{\tilde{p}}\arrow[d, phantom, ""{coordinate, name = Z}]&
    \ker f''
    \arrow[dll,"\delta",rounded corners,to path={ --([xshift=2ex]\tikztostart.east)|- (Z)[near end]\tikztonodes-| ([xshift=-2ex]\tikztotarget.west)-- (\tikztotarget)}]
    \\
    \coker f'\ar{r}{\tilde{j}}&
    \coker f\ar
    {r}{\tilde{q}}&
    \coker f''
    \end{tikzcd}
    \]
    is exact.
    \item If $i$ is a monomorphism, then $\tilde{i}$ is a monomorphism too.
    \item If $q$ is an epimorphisms, then $\tilde{q}$ is an epimorphisms too.
  \end{enumerate}
\end{lem}
\begin{proof}
  Ommited.
\end{proof}
